<div align = center>
  
  <img src='https://cdn.discordapp.com/attachments/787712939133108275/998339081593421994/splash_logo_1.png' width='200'>
  

### A news app to keep yourself updated with latest things happening around you.
  


# App UI

<p align="center">
  <img src="https://github.com/AjCodez/flutter_news_app/blob/master/Screenshots/know%20more.gif" width="300px" style="border-width:5px;border-style:solid;border-color:white;"/>
</p>
  
  ## ![][android] Download APK
  
  ---
  
  [![made-with-flutter](https://img.shields.io/badge/Made%20with-Flutter-1f425f.svg)](https://flutter.dev/) ![Release](https://img.shields.io/github/v/release/Kashish0401/flutter_news_app)
  <br>
**[<kbd> <br> **Know More App** <br> </kbd>][universal-release]** &nbsp;&nbsp;
  
  ---


</div>

## Getting Started

This project is a starting point for a Flutter application.



### Navigation and Routing

- Flutter Navigator is just a stack with special methods like (future, futurebuilder, theme, etc).
- Screens/Routes are just widgets.
- Navigation from one route to another defines workflow of application.

### State Management

- Stateless/Statefull widgets.
- Flutter reflects its UI by reflecting current state.
- State is read while widget is built and can be changed using setState() for Stateful widgets.

### Object Oriented Approach

- Handling various functionalities by binding them in Class and creating Objects of them.
- Reusability of Code, Reducing Redundancy.

### Use of 3rd Party Packages

- Use of external packages provide application with variety of usefull functionalities.
- Make Application Standout.

<div align=center>

## Dependencies Used

---

<kbd> <br> **webview_flutter**: ^3.0.4 <br> </kbd>
<kbd> <br> **http**: ^0.13.4 <br> </kbd>
<kbd> <br> **url_launcher**: ^6.1.5 <br> </kbd>
<kbd> <br> **share_plus**: ^4.0.10 <br> </kbd>
<kbd> <br> **drawerbehavior**: ^0.0.4 <br> </kbd>

## Directory Structure

</div>

```
Know More
|
|-- lib
|   |-- components
|   |   |-- customListTile.dart
|   |   `-- DrawerTile.dart
|   |
|   |-- models
|   |   |-- article_model.dart
|   |   `-- source_model.dart
|   |
|   |-- pages
|   |   |-- article_details_page.dart
|   |   |-- HomePage.dart
|   |   `-- NewsPage.dart
|   |
|   |-- services
|   |   `-- api_service.dart
|   |
|   `-- main.dart
|
`-- pubspec.yaml
```

<h3> Functionalities </h3>

- Sun (Light) and Moon (Dark) Themes
- Latest news Snippets of all across India
- Drawer which allows easy selection of news
    - Business
    - Entertainment
    - Sports
    - Health
    - Science
    - Technology
- WebView to read the detailed news
- Open news in external web browser
- Share news url

<h3> Pre-Requisities </h3>

To build this app from scratch you will need to install Flutter and Dart SDK on your machine:
[Flutter](https://flutter.dev/docs/get-started/install), [Dart](https://dart.dev/get-dart/archive).
<br>Along with this, you will need editor to work on codes like this namely [VSCode](https://code.visualstudio.com/)
or [IntelliJ IDEA](https://www.jetbrains.com/pt-br/idea/).

<h3> How to Run this App </h3>

```bash
# Clone this repository
$ git clone https://github.com/Kashish0401/flutter_news_app

# Install dependencies
$ flutter pub get

# Run the APP on the open device (Android or IOS)
$ flutter run
```


<div align = center>

## Contributors:

<a href="https://github.com/AjCodez/flutter_news_app/graphs/contributors" target="blank"> <img src="https://contrib.rocks/image?repo=AjCodez/flutter_news_app&max=500" /></a>

</div>

<!------------------------------------{ apk }----------------------------------->

[universal-release]: https://github.com/AjCodez/flutter_news_app/releases/download/v1.1.3/Know-More.apk

[android]: https://telegra.ph/file/f2f70a74d2d92c3c7f688.png
